apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ include "backend2.name" . }}-nginx-config
  labels:
    {{- include "backend2.labels" . | nindent 4 }}
data:
  nginx.conf: |-
    user  nginx;

    error_log  /var/log/nginx/error.log warn;
    pid        /var/run/nginx.pid;

    events {
        worker_connections  1024;
    }

    http {
        include /etc/nginx/mime.types;
        default_type application/octet-stream;
        sendfile on;
        client_max_body_size 2050M;
        keepalive_timeout 5s;
        proxy_connect_timeout 60s;
        proxy_read_timeout 300s;
        proxy_send_timeout 300s;
        proxy_force_ranges on;

        log_format  main  '$remote_addr - $remote_user [$time_local] "$request" $status '
            '$body_bytes_sent "$http_referer" "$http_user_agent" "$http_x_forwarded_for"';
        access_log  /var/log/nginx/access.log  main;

        gzip on;
        gzip_disable "msie6";

        gzip_vary on;
        gzip_proxied any;
        gzip_comp_level 6;
        gzip_buffers 16 8k;
        gzip_http_version 1.1;
        gzip_min_length 256;
        gzip_types
        application/atom+xml
        application/geo+json
        application/javascript
        application/x-javascript
        application/json
        application/ld+json
        application/manifest+json
        application/rdf+xml
        application/rss+xml
        application/xhtml+xml
        application/xml
        font/eot
        font/otf
        font/ttf
        image/svg+xml
        text/css
        text/javascript
        text/plain
        text/xml;

        upstream api {
            server 127.0.0.1:8000;
        }

        map $http_upgrade $connection_upgrade{
                default upgrade;
                `` close;
        }

        server {
            listen 9000;
            charset utf-8;

            location /static/ {
                autoindex on;
                alias /var/www/app/static/;
                location ~ "/static/.*\.[a-f0-9]{12}\.[0-9a-z]+$" {
                    expires 365d;
                }
            }

            location / {
                proxy_redirect     off;
                proxy_http_version 1.1;
                proxy_set_header   Upgrade $http_upgrade;
                proxy_set_header   Connection "Upgrade";
                proxy_set_header   Host $host;
                proxy_set_header   X-Real-IP $remote_addr;
                proxy_set_header   X-Forwarded-For $proxy_add_x_forwarded_for;
                proxy_pass http://api;
            }
        }
    }
